var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import _ from 'lodash';
import moment from 'moment';
import BasicItem from '../BasicItem';
import { Radio } from "antd";
import FormItemComponentDecorator from '../../decorator/FormItemComponent';

var RadioGroup = Radio.Group;

function component(BasicItemComponent) {
  var _class;

  var FRadioGroup = FormItemComponentDecorator(_class = function (_React$Component) {
    _inherits(FRadioGroup, _React$Component);

    function FRadioGroup() {
      _classCallCheck(this, FRadioGroup);

      return _possibleConstructorReturn(this, (FRadioGroup.__proto__ || Object.getPrototypeOf(FRadioGroup)).apply(this, arguments));
    }

    _createClass(FRadioGroup, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            options = _props.options,
            other = _objectWithoutProperties(_props, ['options']);

        other.targetComponent = RadioGroup;
        other.type = "radiogroup";
        this.propsAdapter(other);
        return React.createElement(
          BasicItemComponent,
          other,
          options && options[0] && options.map(function (v, k) {
            return React.createElement(
              Radio,
              { value: v.value, key: k },
              v.label
            );
          })
        );
      }
    }]);

    return FRadioGroup;
  }(React.Component)) || _class;

  return FRadioGroup;
}

export default component(BasicItem);