var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import Icon from 'antd/lib/icon';
import _ from 'lodash';

var IconGroup = function (_React$Component) {
  _inherits(IconGroup, _React$Component);

  function IconGroup() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, IconGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = IconGroup.__proto__ || Object.getPrototypeOf(IconGroup)).call.apply(_ref, [this].concat(args))), _this), _this.onIconClick = function (button_type, e) {
      _this.props.onIconClick && _this.props.onIconClick(button_type, e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(IconGroup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          action = _props.action,
          data = _props.data,
          index = _props.index;

      var group;
      if (action) {
        if (_.isBoolean(action)) {
          action = {
            up_action: true,
            down_action: true,
            add_action: true,
            delete_action: true
          };
        }
        var upIcon = React.createElement(Icon, {
          className: 'mr10',
          type: 'arrow-up',
          onClick: function onClick(e) {
            _this2.onIconClick("up", e);
          }
        });
        var downIcon = React.createElement(Icon, {
          className: 'mr10',
          type: 'arrow-down',
          onClick: function onClick(e) {
            _this2.onIconClick("down", e);
          }
        });
        var addIcon = React.createElement(Icon, {
          className: 'mr10',
          type: 'plus',
          onClick: function onClick(e) {
            _this2.onIconClick("add", e);
          }
        });
        var deleteIcon = React.createElement(Icon, {
          className: 'mr10',
          type: 'delete',
          onClick: function onClick(e) {
            _this2.onIconClick("delete", e);
          }
        });

        if (!action.up_action) {
          upIcon = false;
        }
        if (!action.down_action) {
          downIcon = false;
        }
        if (!action.add_action) {
          addIcon = false;
        }
        if (!action.delete_action) {
          deleteIcon = false;
        }
        if (index !== undefined && index === 0) {
          upIcon = false;
        }
        if (index !== undefined && data !== undefined && index === data.length - 1) {
          downIcon = false;
        }
        if (data !== undefined && data.length - 1 === 0) {
          deleteIcon = false;
        }
        group = React.createElement(
          'span',
          { className: 'icon-group-con' },
          upIcon,
          downIcon,
          addIcon,
          deleteIcon
        );
      }
      return group;
    }
  }]);

  return IconGroup;
}(React.Component);

export default IconGroup;