'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;

var Button = (_temp = _class = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'getDealProp',
    value: function getDealProp(props, index, defaultValue) {
      if (!props[index]) {
        if (this.context[index]) {
          props[index] = this.context[index];
        } else {
          props[index] = defaultValue;
        }
      }
    }
  }, {
    key: 'addOtherPropsFromFormBuilder',
    value: function addOtherPropsFromFormBuilder(props) {
      this.getDealProp(props, "size", "default");
      return props;
    }
  }, {
    key: 'addFormItemPropsFromFormBuilder',
    value: function addFormItemPropsFromFormBuilder(props) {
      this.getDealProp(props, "hasFeedback", false);
      this.getDealProp(props, "labelCol", null);
      this.getDealProp(props, "wrapperCol", null);
      return props;
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var storage = props.storage,
          children = props.children,
          value = props.value,
          buttonType = props.buttonType,
          _props$formItemProps = props.formItemProps,
          formItemProps = _props$formItemProps === undefined ? {} : _props$formItemProps,
          other = _objectWithoutProperties(props, ['storage', 'children', 'value', 'buttonType', 'formItemProps']);

      other = this.addOtherPropsFromFormBuilder(other);
      formItemProps = this.addFormItemPropsFromFormBuilder(formItemProps);
      other.type = buttonType;
      if (!children) {
        children = value;
      }
      return _react2.default.createElement(
        FormItem,
        formItemProps,
        _react2.default.createElement(
          _button2.default,
          other,
          children
        )
      );
    }
  }]);

  return Button;
}(_react2.default.Component), _class.contextTypes = {
  size: _react2.default.PropTypes.string,
  hasFeedback: _react2.default.PropTypes.bool,
  labelCol: _react2.default.PropTypes.object,
  wrapperCol: _react2.default.PropTypes.object
}, _temp);
exports.default = Button;