'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _BasicItem = require('../BasicItem');

var _BasicItem2 = _interopRequireDefault(_BasicItem);

var _FormItemComponent = require('../../decorator/FormItemComponent');

var _FormItemComponent2 = _interopRequireDefault(_FormItemComponent);

var _en_US = require('./en_US');

var _en_US2 = _interopRequireDefault(_en_US);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function component(BasicItemComponent) {
  var _class, _class2, _temp;

  var InputNumber = (0, _FormItemComponent2.default)(_class = (_temp = _class2 = function (_React$Component) {
    _inherits(InputNumber, _React$Component);

    function InputNumber(props) {
      _classCallCheck(this, InputNumber);

      return _possibleConstructorReturn(this, (InputNumber.__proto__ || Object.getPrototypeOf(InputNumber)).call(this, props));
    }

    _createClass(InputNumber, [{
      key: 'getInfoObject',


      //定义rule,type等信息 
      value: function getInfoObject(type) {
        var locale = this.props.locale;

        if (!locale) {
          locale = this.context.antLocale;
        }
        var rules = InputNumber.getRules(locale);
        switch (type) {
          case "float":
            return {
              rules: rules.float,
              type: "number"
            };
          case "integer":
            return {
              rules: rules.integer,
              type: "number"
            };
          default:
            return {
              type: "number",
              rules: []
            };
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            type = _props.type,
            rules = _props.rules,
            other = _objectWithoutProperties(_props, ['type', 'rules']);

        other.type = "number";
        if (other.value) {
          other.value = Number(other.value);
        }
        other.targetComponent = _input2.default;
        var infoObject = this.getInfoObject(type);
        var temp_rules = [];
        Array.prototype.push.apply(temp_rules, rules);
        Array.prototype.push.apply(temp_rules, infoObject.rules || []);
        other.rules = temp_rules;
        other.type = infoObject.type;
        this.propsAdapter(other);
        return _react2.default.createElement(BasicItemComponent, other);
      }
    }], [{
      key: 'getRules',

      //其他地方也可以访问这个rules，测试就要用到
      value: function getRules(replaceLocale) {
        var locale;
        if (replaceLocale) {
          locale = replaceLocale;
        } else {
          locale = _en_US2.default;
        }
        if (!locale.FormBuilderFloatInput) {
          locale.FormBuilderFloatInput = _en_US2.default.FormBuilderFloatInput;
        }
        if (!locale.FormBuilderIntegerInput) {
          locale.FormBuilderIntegerInput = _en_US2.default.FormBuilderIntegerInput;
        }
        //这里运行了多次，没想到更好办法，目前先这样处理
        return {
          integer: [{
            type: "integer",
            message: locale.FormBuilderIntegerInput.formatErrorMsg || _en_US2.default.FormBuilderIntegerInput.formatErrorMsg
          }],
          float: [{
            type: "float",
            message: locale.FormBuilderFloatInput.formatErrorMsg || _en_US2.default.FormBuilderFloatInput.formatErrorMsg
          }]
        };
      }
    }]);

    return InputNumber;
  }(_react2.default.Component), _class2.contextTypes = {
    antLocale: _react2.default.PropTypes.object
  }, _temp)) || _class;

  return InputNumber;
}

exports.default = component(_BasicItem2.default);