'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _BasicItem = require('../BasicItem');

var _BasicItem2 = _interopRequireDefault(_BasicItem);

var _datePicker = require('antd/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

var _FormItemComponent = require('../../decorator/FormItemComponent');

var _FormItemComponent2 = _interopRequireDefault(_FormItemComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MonthPicker = _datePicker2.default.MonthPicker;


function component(BasicItemComponent) {
  var _class;

  var FMonthPicker = (0, _FormItemComponent2.default)(_class = function (_React$Component) {
    _inherits(FMonthPicker, _React$Component);

    function FMonthPicker() {
      _classCallCheck(this, FMonthPicker);

      return _possibleConstructorReturn(this, (FMonthPicker.__proto__ || Object.getPrototypeOf(FMonthPicker)).apply(this, arguments));
    }

    _createClass(FMonthPicker, [{
      key: 'render',
      value: function render() {
        var other = _objectWithoutProperties(this.props, []);

        other.targetComponent = MonthPicker;
        other.type = "monthpicker";
        if (_lodash2.default.isString(other.value)) {
          other.value = new _moment2.default(other.value, other.format || "YYYY-MM");
        }
        this.propsAdapter(other);
        return _react2.default.createElement(BasicItemComponent, other);
      }
    }]);

    return FMonthPicker;
  }(_react2.default.Component)) || _class;

  return FMonthPicker;
}

exports.default = component(_BasicItem2.default);