'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Cascader = exports.Password = exports.RadioGroup = exports.CheckboxGroup = exports.RangePicker = exports.MonthPicker = exports.DatePicker = exports.TimePicker = exports.Button = exports.Select = exports.InputNumber = exports.Input = exports.FormBuilderConfiger = exports.FormBuilder = exports.FormItem = undefined;

require('./polyfill');

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _Input = require('./components/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputNumber = require('./components/InputNumber');

var _InputNumber2 = _interopRequireDefault(_InputNumber);

var _Select = require('./components/Select');

var _Select2 = _interopRequireDefault(_Select);

var _Button = require('./components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TimePicker = require('./components/TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _DatePicker = require('./components/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _MonthPicker = require('./components/MonthPicker');

var _MonthPicker2 = _interopRequireDefault(_MonthPicker);

var _RangePicker = require('./components/RangePicker');

var _RangePicker2 = _interopRequireDefault(_RangePicker);

var _CheckboxGroup = require('./components/CheckboxGroup');

var _CheckboxGroup2 = _interopRequireDefault(_CheckboxGroup);

var _RadioGroup = require('./components/RadioGroup');

var _RadioGroup2 = _interopRequireDefault(_RadioGroup);

var _Password = require('./components/Password');

var _Password2 = _interopRequireDefault(_Password);

var _Cascader = require('./components/Cascader');

var _Cascader2 = _interopRequireDefault(_Cascader);

var _FormBuilder = require('./components/FormBuilder');

var _FormBuilder2 = _interopRequireDefault(_FormBuilder);

var _FormBuilderConfiger = require('./components/FormBuilderConfiger');

var _FormBuilderConfiger2 = _interopRequireDefault(_FormBuilderConfiger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _form2.default.Item;

exports.default = _FormBuilder2.default;
exports.FormItem = FormItem;
exports.FormBuilder = _FormBuilder2.default;
exports.FormBuilderConfiger = _FormBuilderConfiger2.default;
exports.Input = _Input2.default;
exports.InputNumber = _InputNumber2.default;
exports.Select = _Select2.default;
exports.Button = _Button2.default;
exports.TimePicker = _TimePicker2.default;
exports.DatePicker = _DatePicker2.default;
exports.MonthPicker = _MonthPicker2.default;
exports.RangePicker = _RangePicker2.default;
exports.CheckboxGroup = _CheckboxGroup2.default;
exports.RadioGroup = _RadioGroup2.default;
exports.Password = _Password2.default;
exports.Cascader = _Cascader2.default;